

CraftNode = class( Turbine.UI.TreeNode );

function CraftNode:Constructor(p, hightlight, parent)
	self.player = p;
	
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( 312, 35 );
	--self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );

	self.leftbox = Turbine.UI.Label();
	self.leftbox:SetParent( self );
	self.leftbox:SetPosition(0, 0);
	self.leftbox:SetSize(37, 35);
	self.leftbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.leftbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box_l.tga");	
	self.rightbox = Turbine.UI.Label();
	self.rightbox:SetParent( self );
	self.rightbox:SetSize(6, 35);
	self.rightbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.rightbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box_r.tga");
	self.middlebox = Turbine.UI.Label();
	self.middlebox:SetParent( self );
	--self.middlebox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.middlebox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box_m.tga");
	self.middlebox:SetPosition(37, 0);
	
	self.playerNameLabel = Turbine.UI.Label();
	self.playerNameLabel:SetParent( self );
	self.playerNameLabel:SetSize( 180, 28 );
	self.playerNameLabel:SetPosition( 42, 3 );
	self.playerNameLabel:SetZOrder(100);
	self.playerNameLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.playerNameLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.playerNameLabel:SetMouseVisible( false );
	--self.playerNameLabel:SetBackColor(Turbine.UI.Color( 0, 0, 1 ));
	-- if(self.player.data.level == nil) then
		-- self.playerNameLabel:SetText(self.player.name);
		-- self.playerNameLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	-- else
	self.playerNameLabel:SetText("["..self.player.data.level.."] "..self.player.name);
	-- end
	if(hightlight==true) then
		self.playerNameLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	end
	
	self.classLabel = Turbine.UI.Control();
	self.classLabel:SetParent( self );
	self.classLabel:SetSize( 20, 20 );
	self.classLabel:SetPosition( 9, 7 );

	if(self.player.data.playerClass == 172) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_champion_20.tga";
	elseif(self.player.data.playerClass == 214) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_beorning_20.tga";
	elseif(self.player.data.playerClass == 40) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_burglar_20.tga";
	elseif(self.player.data.playerClass == 23) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_guardian_20.tga";
	elseif(self.player.data.playerClass == 194) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_warden_20.tga";
	elseif(self.player.data.playerClass == 193) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_runekeeper_20.tga";
	elseif(self.player.data.playerClass == 185) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_loremaster_20.tga";
	elseif(self.player.data.playerClass == 162) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_hunter_20.tga";
	elseif(self.player.data.playerClass == 31) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_minstrel_20.tga";
	elseif(self.player.data.playerClass == 24) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_captain_20.tga";
	elseif(self.player.data.playerClass == 195) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_brawler_20.tga";
	else
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga";
		self.classLabel:SetPosition( 6, 5 );
		self.classLabel:SetSize( 26, 24 );
		found = false;
	end
	self.classLabel:SetBackground(self.classLabel.defaultBackground);
	self.classLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--self.classLabel:SetMouseVisible( false );
	self.classLabel.tooltip = GenericTooltip(self.classLabel);
	self.classLabel.tooltip:AddLayer( _("DELCHAR"), Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
	self.classLabel.tooltip:AddLayer(_("DELCHAR_DESCRIPTION"),  Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);


	local iconeTop = 3;

	self.prof1Label = Turbine.UI.Control();
	self.prof1Label:SetParent( self );
	self.prof1Label:SetSize( 26, 24 );
	self.prof1Label:SetPosition( 204, iconeTop+4 );
	self.prof1Label:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.prof1Label:SetBackground( "WalmPlugins/BandOfFarmers/pictures/"..self:GetIconeByCraftName(self.player.data.profession[1].name) );
	self.prof1Label.MouseClick = function()
		parent:HightlightProfession(self.player.data.profession[1].name);
	end	
	self.prof2Label = Turbine.UI.Control();
	self.prof2Label:SetParent( self );
	self.prof2Label:SetSize( 26, 24 );
	self.prof2Label:SetPosition( 204, iconeTop+4 );
	self.prof2Label:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.prof2Label:SetBackground( "WalmPlugins/BandOfFarmers/pictures/"..self:GetIconeByCraftName(self.player.data.profession[2].name) );
	self.prof2Label.MouseClick = function()
		parent:HightlightProfession(self.player.data.profession[1].name);
	end		
	self.prof3Label = Turbine.UI.Control();
	self.prof3Label:SetParent( self );
	self.prof3Label:SetSize( 26, 24 );
	self.prof3Label:SetPosition( 204, iconeTop+4 );
	self.prof3Label:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.prof3Label:SetBackground( "WalmPlugins/BandOfFarmers/pictures/"..self:GetIconeByCraftName(self.player.data.profession[3].name) );
	self.prof3Label.MouseClick = function()
		parent:HightlightProfession(self.player.data.profession[1].name);
	end	
	
	self.prof1SlotLabel = Turbine.UI.Control();
	self.prof1SlotLabel:SetParent( self );
	self.prof1SlotLabel:SetSize( 32, 32 );
	self.prof1SlotLabel:SetPosition( 200, iconeTop );
	self.prof1SlotLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/overlay_OK.tga" );
	self.prof1SlotLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.prof1SlotLabel:SetMouseVisible(false);
	self.prof1SlotLabel:SetVisible(false);
	self.prof2SlotLabel = Turbine.UI.Control();
	self.prof2SlotLabel:SetParent( self );
	self.prof2SlotLabel:SetSize( 32, 32 );
	self.prof2SlotLabel:SetPosition( 200, iconeTop );
	self.prof2SlotLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/overlay_OK.tga" );
	self.prof2SlotLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.prof2SlotLabel:SetMouseVisible(false);
	self.prof2SlotLabel:SetVisible(false);
	self.prof3SlotLabel = Turbine.UI.Control();
	self.prof3SlotLabel:SetParent( self );
	self.prof3SlotLabel:SetSize( 32, 32 );
	self.prof3SlotLabel:SetPosition( 200, iconeTop );
	self.prof3SlotLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/overlay_OK.tga" );
	self.prof3SlotLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.prof3SlotLabel:SetMouseVisible(false);
	self.prof3SlotLabel:SetVisible(false);
	  
	self:UpdateNodeData(self.player);

	self.MouseEnter = function()
		self.classLabel:SetBackground("WalmPlugins/BandOfFarmers/pictures/delete.tga");
	end
	self.MouseLeave = function()
		self.classLabel:SetBackground(self.classLabel.defaultBackground);
	end
	self.classLabel.MouseClick = function()
		bofDlg:DeleteCharacterData(self.player.name);
	end
end

function CraftNode:UpdateResponsive(width, height)
	self:SetWidth(width);
	self.rightbox:SetPosition(width-6, 0);
	self.middlebox:SetSize(width-43, 35);
	
	self.prof1SlotLabel:SetLeft(width-112);
	self.prof1Label:SetLeft(self.prof1SlotLabel:GetLeft()+3);
	self.prof2SlotLabel:SetLeft(width-72);
	self.prof2Label:SetLeft(self.prof2SlotLabel:GetLeft()+3);
	self.prof3SlotLabel:SetLeft(width-32);
	self.prof3Label:SetLeft(self.prof3SlotLabel:GetLeft()+3);
end

function CraftNode:GetPlayer()
	return self.player;
end

function CraftNode:HightlightProfession(name)
	self.prof1SlotLabel:SetVisible( self.prof1Label.craftName==name );
	self.prof2SlotLabel:SetVisible( self.prof2Label.craftName==name );
	self.prof3SlotLabel:SetVisible( self.prof3Label.craftName==name );
end

function CraftNode:UpdateNodeData(p)
	if (p~= nil and p.name == self.player.name)  then
		self.player = p;
		local maxlvl = 14;
		self:UpdateNodeDatas(p, maxlvl, self.player.data.profession[1], self.prof1SlotLabel, self.prof1Label);
		self:UpdateNodeDatas(p, maxlvl, self.player.data.profession[2], self.prof2SlotLabel, self.prof2Label);
		self:UpdateNodeDatas(p, maxlvl, self.player.data.profession[3], self.prof3SlotLabel, self.prof3Label);
	end
end

function CraftNode:UpdateNodeDatas(p, maxlvl, playerProdData, slotLabel, profLabel)
	profLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/"..self:GetIconeByCraftName(playerProdData.name, playerProdData.level==maxlvl) );
	profLabel.craftName = playerProdData.name;
	
	profLabel.tooltip = GenericTooltip(profLabel);
	profLabel.tooltip:AddLayer(playerProdData.name, Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.MiddleCenter, Turbine.UI.Lotro.Font.TrajanProBold22, Turbine.UI.FontStyle.Outline);
	profLabel.tooltip:AddLayer( _("LEVEL"), Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);	
	local str = "    "..self:GetCraftLevelById(playerProdData.level).."  ("..playerProdData.level.."/"..maxlvl..")";
	profLabel.tooltip:AddLayer(str, Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
	if (playerProdData.levelXP ~= "0/0") then
		profLabel.tooltip:AddLayer("    ".._("MISSINGXP")..playerProdData.levelXP.."\n", Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
	end
	
	profLabel.tooltip:AddLayer( _("MASTERYLEVEL"), Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
	str = "    "..self:GetCraftLevelById(playerProdData.mastery).."  ("..playerProdData.level.."/"..maxlvl..")";
	profLabel.tooltip:AddLayer(str,  Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
	if(playerProdData.masteryXP ~= "0/0") then
		profLabel.tooltip:AddLayer("    ".._("MISSINGXP")..playerProdData.masteryXP, Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
	end

	if(playerProdData.level<2) then
		profLabel:SetBlendMode( 1 );
		profLabel:SetOpacity( 0.9 ); 
	end
end

function CraftNode:GetCraftLevelById(level)
	if(level==1) then	return _("LEVEL1");
	elseif (level==2) then return _("LEVEL2");
	elseif (level==3) then return _("LEVEL3");
	elseif (level==4) then return _("LEVEL4");
	elseif (level==5) then return _("LEVEL5");
	elseif (level==6) then return _("LEVEL6");
	elseif (level==7) then return _("LEVEL7");
	elseif (level==8) then return _("LEVEL8");
	elseif (level==9) then return _("LEVEL9");
	elseif (level==10) then return _("LEVEL10");
	elseif (level==11) then return _("LEVEL11");
	elseif (level==12) then return _("LEVEL12");
	elseif (level==13) then return _("LEVEL13");
	elseif (level==14) then return _("LEVEL14");
	elseif (level==0) then return _("LEVEL0");
	else return _("LEVEL?");
	end
end

function CraftNode:GetIconeByCraftName(craft, gold)
	if(_TEST("TAILOR", craft)) then
		if(gold==true) then return "actionPicker_icon_craft_tailor_gold.tga"; end
		return "actionPicker_icon_craft_tailor.tga";
	elseif(_TEST("COOKER", craft)) then
		if(gold==true) then return "actionPicker_icon_cook_gold.tga"; end
		return "actionPicker_icon_cook.tga";
	elseif(_TEST("FARMER", craft)) then
		if(gold==true) then return "actionPicker_icon_craft_farmer_gold.tga"; end
		return "actionPicker_icon_craft_farmer.tga";
	elseif(_TEST("FORESTER", craft)) then
		if(gold==true) then return "actionPicker_icon_craft_forester_gold.tga"; end
		return "actionPicker_icon_craft_forester.tga";
	elseif(_TEST("PROSPECTOR", craft)) then
		if(gold==true) then return "actionPicker_icon_craft_prospector_gold.tga"; end
		return "actionPicker_icon_craft_prospector.tga";
	elseif(_TEST("METALSMITH", craft)) then
		if(gold==true) then return "actionPicker_icon_craft_metalsmith_gold.tga"; end
		return "actionPicker_icon_craft_metalsmith.tga";
	elseif(_TEST("SCHOLAR", craft)) then
		if(gold==true) then return "actionPicker_icon_craft_scholar_gold.tga"; end
		return "actionPicker_icon_craft_scholar.tga";
	elseif(_TEST("WEAPONSMITH", craft)) then
		if(gold==true) then return "actionPicker_icon_craft_weaponsmith_gold.tga"; end
		return "actionPicker_icon_craft_weaponsmith.tga";
	elseif(_TEST("WOODWORKER", craft)) then
		if(gold==true) then return "actionPicker_icon_craft_woodworker_gold.tga"; end
		return "actionPicker_icon_craft_woodworker.tga";
	else
		if(gold==true) then return "actionPicker_icon_craft_jeweller_gold.tga"; end
		return "actionPicker_icon_craft_jeweller.tga";
	end
end