
FarmNode = class( Turbine.UI.TreeNode );

function FarmNode:Constructor(parent, pData, hightlight, pDataId)
	self.pName = pData.name;
	self.pData = pData;
	self.pparent = parent;
	self.pDataId = pDataId;
	self.hightlight = hightlight;
	Turbine.UI.TreeNode.Constructor( self );  
	self.nativeHeight = 55;
	self:SetSize( 312, self.nativeHeight );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--self:SetBackground("WalmPlugins/BandOfFarmers/background_blue.tga");
	
	self.farmList = {
		["R_XP"]={key="XPVERTUES", ico="tag_vertues.tga",config="farm_show_vertue"},
		["R_BRAISE"]={key="BRAISES", ico="tag_braises.tga",config="farm_show_braise"},
		["R_GRAIN"]={key="GRAINS", ico="tag_grains.tga",config="farm_show_grains"},
		["R_RUNE"]={key="RUNES", ico="tag_traceries.tga",config="farm_show_traceries"},
		["R_LEG"]={key="EVEIL", ico="tag_parcho.tga",config="farm_show_parcho"},
		["R_CUSTOM"]={key="CUSTOM", ico="tag_custrep.tga",config="farm_custrep"},
		["R_REPUT"]={key="REPUT", ico="tag_reput.tga",config="farm_reput"}
	};
	if(settings.farmList==nil or table.getn(settings.farmList)~=7) then 
		settings.farmList = {"R_XP", "R_RUNE", "R_BRAISE", "R_GRAIN", "R_CUSTOM", "R_REPUT"};
	end
	self.lefttopbox = Turbine.UI.Label();
	self.lefttopbox:SetParent( self );
	self.lefttopbox:SetPosition(0, 0);
	self.lefttopbox:SetSize(37, 30);
	self.lefttopbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.lefttopbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_lt.tga");	
	self.leftmidbox = Turbine.UI.Label();
	self.leftmidbox:SetParent( self );
	self.leftmidbox:SetPosition(0, 30);
	self.leftmidbox:SetSize(37, 1);
	self.leftmidbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.leftmidbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_lm.tga");
	self.leftbotbox = Turbine.UI.Label();
	self.leftbotbox:SetParent( self );
	self.leftbotbox:SetPosition(0, 30);
	self.leftbotbox:SetSize(37, 4);
	self.leftbotbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.leftbotbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_lb.tga");	
	self.righttopbox = Turbine.UI.Label();
	self.righttopbox:SetParent( self );
	self.righttopbox:SetPosition(0, 0);
	self.righttopbox:SetSize(6, 30);
	self.righttopbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.righttopbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_rt.tga");	
	self.rightmidbox = Turbine.UI.Label();
	self.rightmidbox:SetParent( self );
	self.rightmidbox:SetPosition(0, 30);
	self.rightmidbox:SetSize(6, 1);
	self.rightmidbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.rightmidbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_rm.tga");
	self.rightbotbox = Turbine.UI.Label();
	self.rightbotbox:SetParent( self );
	self.rightbotbox:SetPosition(0, 30);
	self.rightbotbox:SetSize(6, 4);
	self.rightbotbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.rightbotbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_rb.tga");
	self.centtopbox = Turbine.UI.Label();
	self.centtopbox:SetParent( self );
	self.centtopbox:SetPosition(37, 0);
	self.centtopbox:SetSize(1, 30);
	self.centtopbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.centtopbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_ct.tga");	
	self.centmidbox = Turbine.UI.Label();
	self.centmidbox:SetParent( self );
	self.centmidbox:SetPosition(37, 30);
	self.centmidbox:SetSize(1, 1);
	self.centmidbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.centmidbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_cm.tga");
	self.centbotbox = Turbine.UI.Label();
	self.centbotbox:SetParent( self );
	self.centbotbox:SetPosition(37, 30);
	self.centbotbox:SetSize(1, 4);
	self.centbotbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.centbotbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_cb.tga");	
	
	self.playerNameLabel = Turbine.UI.Label();
	self.playerNameLabel:SetParent( self );
	self.playerNameLabel:SetSize( 180, 28 );
	self.playerNameLabel:SetPosition( 42, 3 );
	self.playerNameLabel:SetZOrder(100);
	self.playerNameLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.playerNameLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.playerNameLabel:SetMouseVisible( false );
	--self.playerNameLabel:SetBackColor(Turbine.UI.Color( 0, 0, 1 ));
	self.playerNameLabel:SetText("["..(self.pData.data.level or "??").."] "..self.pName);
	if(hightlight==true) then
		self.playerNameLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	end
	
	self.classLabel = Turbine.UI.Control();
	self.classLabel:SetParent( self );
	self.classLabel:SetSize( 20, 20 );
	self.classLabel:SetPosition( 9, 7 );
	local found = true;
	if(self.pData.data.playerClass == 172) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_champion_20.tga";
	elseif(self.pData.data.playerClass == 214) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_beorning_20.tga";
	elseif(self.pData.data.playerClass == 40) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_burglar_20.tga";
	elseif(self.pData.data.playerClass == 23) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_guardian_20.tga";
	elseif(self.pData.data.playerClass == 194) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_warden_20.tga";
	elseif(self.pData.data.playerClass == 193) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_runekeeper_20.tga";
	elseif(self.pData.data.playerClass == 185) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_loremaster_20.tga";
	elseif(self.pData.data.playerClass == 162) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_hunter_20.tga";
	elseif(self.pData.data.playerClass == 31) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_minstrel_20.tga";
	elseif(self.pData.data.playerClass == 24) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_captain_20.tga";
	elseif(self.pData.data.playerClass == 215) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_brawler_20.tga";
	else
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga";
		self.classLabel:SetPosition( 6, 5 );
		self.classLabel:SetSize( 26, 24 );
		found = false;
	end
	self.classLabel:SetBackground(self.classLabel.defaultBackground);
	self.classLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--self.classLabel:SetMouseVisible( false );
	self.classLabel.tooltip = GenericTooltip(self.classLabel);
	self.classLabel.tooltip:AddLayer( _("DELCHAR"), Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
	self.classLabel.tooltip:AddLayer(_("DELCHAR_DESCRIPTION"),  Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);

	self.treeView = Turbine.UI.TreeView();
    self.treeView:SetParent( self );
    self.treeView:SetIndentationWidth( 15 );

	local days = {TRAD("dimanche", "sunday", "sonntag"), TRAD("lundi", "monday", "montag"), TRAD("mardi", "tuesday", "dienstag"), TRAD("mercredi", "wednesday", "mittwoch"), TRAD("jeudi", "thursday", "donnerstag"), TRAD("vendredi", "friday", "freitag"), TRAD("samedi", "saturday", "samstag"), TRAD("jour", "day", "tag"), TRAD("jeudis et dimanche", "thursdays and sunday", "donnerstags und sonntag")};
	self.days=days;
	self.quests = { 
		{5057, TRAD("Pi\195\168ces d'argent de Gundabad contre braises", "Silver Coins of Gundabad for Embers"), 1, days[1],TRAD("Intendant (Zidil-nesad)","Quartermaster (Zidil-nesad)"), {{"R_BRAISE", 500}}},
		{5055, TRAD("D\195\169fis de Gundabad (hebdomadaires)", "Challenges of Gundabad (Weekly)"), 5, days[5],"Zova (Vernozal)", {{"R_REPUT", 10000, TRAD("Allégeance : Le clan de Zhelruka","Allegiance : Zhelruka Clan")},{"R_RUNE", 7, 131},{"R_XP", 2000}}},
		{5055, TRAD("Reconqu\195\170te de la Montagne (hebdomadaire)", "Reconqu\195\170te de la Montagne (hebdomadaire)"), 5, days[5],"Zova (Vernozal)", {{"R_REPUT", 10000, TRAD("Allégeance : Le clan de Zhelruka","Allegiance : Zhelruka Clan")},{"R_RUNE", 7, 131},{"R_XP", 2000}}},
		{5055, TRAD("Missions de Gundabad (hebdomadaires)", "Missions of Gundabad (Weekly)"), 5, days[5],"Zova (Vernozal)", {{"R_REPUT", 5000, TRAD("Allégeance : Le clan de Zhelruka","Allegiance : Zhelruka Clan")}}},
		{5056, TRAD("Missions de Gundabad (quotidien)", "Missions of Gundabad (Daily)"), 5, days[5],"Zova (Vernozal)", {{"R_REPUT", 1000, TRAD("Allégeance : Le clan de Zhelruka","Allegiance : Zhelruka Clan")}}},
		{5012, TRAD("\195\137change objets d'artisanat contre grains", "Craft for Motes"), 1, days[1],TRAD("Vendeur de Grain d'Enchantement (Fontaine de Bree)", "Mote Craft Trader (Bree fountain)"), {{"R_GRAIN", 250}}},
		{5017, TRAD("\195\137change Gulmarks contre grains", "Gulmarks for Motes"), 1, days[1],"Ragnild (Hultvis)",{{"R_GRAIN", 200}}},
		{5006, TRAD("L'effort de guerre : Missions pour les Gabil'akk\195\162 (hebdomadaire)", "The War Effort : Missions for the Cause (Weekly)"), 5, days[5],nil,{{"R_GRAIN", 400}}},
		{5007, TRAD("Les Reconqu\195\169rants de Gundabad : Missions pour les Gabil'akk\195\162", "March on Gundabad: Missions for the Cause"), 8, days[8],"Elof (Annak-khurfu)",{{"R_GRAIN", 42}}},
		{5001, TRAD("\195\137change de marques des Longues Barbes contre des grains", "Longbeard Marks for Motes"), 1, days[1],TRAD("Intendendant de Skarhald", "Skarhald Quartermaster"),{{"R_GRAIN", 100}}},
		{5010, "La reconqu\195\170te des Montagnes Grises", 5, days[5],nil,{{"R_GRAIN", 300},{"R_RUNE", 1, 121}}},
		{5009, TRAD("\195\137change objets d'artisanat contre braises", "Craft for Embers"), 1, days[1],nil,{{"R_BRAISE", 1000}}},
		{5005, TRAD("Pi\195\168ces de cuivre de Gundabad contre grains", "Copper Coins of Gundabad for Motes"), 1, days[1],nil,{{"R_GRAIN", 500}}},
		{5008, TRAD("En mission (hebdomadaire)", "On A Mission (Weekly)"), 5, days[5],nil,{{"R_BRAISE", 500},{"R_XP", 1000},{"R_PACKLEG", 1}}},
		{5021, TRAD("En mission continue (hebdomadaire)", "On A Continuing Mission (Weekly)"), 5, days[5],nil,{{"R_BRAISE", 500},{"R_XP", 1000},{"R_PACKLEG", 1}}},
		{5004, TRAD("Protecteurs des Terres sauvages : primes", "Protectors of Wilderland: Bounties"), 5, days[5], TRAD("Tableau de primes (Limlok)", "Bounty board (Limlok)"),{{"R_GRAIN", 300},{"R_RUNE", 2, 121}}},
		{5000, TRAD("Sceaux d'Imlad Ithil contre des grains", "Sigils of Imlad Ithil for Motes"), 1, days[1],TRAD("Intendant (Imlad Morgul)", "Quartermaster (Imlad Morgul)"),{{"R_GRAIN", 500}}},
		{5002, TRAD("Imlad Morgul : La reconqu\195\170te", "Imlad Morgul: The Reclamation"), 5, days[5],TRAD("prenant une qu\195\180te d'instance de Minas Morgul", "by taking a quest from Minas Morgul instances"),{{"R_GRAIN", 500},{"R_RUNE", 1, 121}}},
		{5003, TRAD("Imlad Morgul : Voile de sorcellerie", "Imlad Morgul: Vale of Sorcery"), 5, days[5],TRAD("entrant dans une instance de Minas Morgul", "entering in a Minas Morgul instance"),{{"R_GRAIN", 500},{"R_RUNE", 1, 121}}},
		{5011, TRAD("Imlad Morgul : Menaces perp\195\169tuelles", "Imlad Morgul: Continued Threats"), 5, days[5],nil,{{"R_GRAIN", 500},{"R_RUNE", 1, 121}}},
		{5018, TRAD("Des parchemins d'\195\169veil contre des pi\195\168ces d'argent de l'Arm\195\169e de l'Ouest (quotidien)","Scrolls of Empowerment for Host of the West Silver Pieces (Daily)"), 8, days[8],TRAD("Indendant (Camp de l'Armée de l'Ouest)", " Quartermaster (Camp of the Host)"),{{"R_RUNE", 2, 101}}},
		{5019, TRAD("Des parchemins d'\195\169veil contre des pi\195\168ces d'argent de l'Arm\195\169e de l'Ouest (hebdomadaire)","Scrolls of Empowerment for Host of the West Silver Pieces (Weekly)"), 5, days[5],TRAD("Indendant (Camp de l'Armée de l'Ouest)", " Quartermaster (Camp of the Host)"),{{"R_RUNE", 2, 101}}},
		{5014, TRAD("Restauration des Trois Royaumes", "Restoring the Three Kingdoms"), 5, days[5],TRAD("Roi Thorin III", "King Thorin III"),{{"R_GRAIN", 300},{"R_RUNE", 2, 106}}},
		{5013, TRAD("Prot\195\169ger les Beornides", "Protecting the Beornings"), 9, days[9],"Ragnild (Hultvis)",{{"R_GRAIN", 300},{"R_EVEIL", 3, 83}}},
		{5015, TRAD("Prot\195\169ger les Elfes", "Protecting the Elves"), 9, days[9],"Hithril (Hultvis)",{{"R_GRAIN", 300},{"R_EVEIL", 3, 83}}},
		{5016, TRAD("Prot\195\169ger les Hommes des bois", "Protecting the Woodmen"), 9, days[9],"Audvak (Hultvis)",{{"R_GRAIN", 300},{"R_EVEIL", 3, 83}}},
		{5020, TRAD("Les Reconqu\195\169rants de Gundabad : T\195\162ches suppl\195\169mentaires (quotidien)", "March on Gundabad: More tasks (Weekly)"), 5, days[5],"Hlothi (Annak-khurfu)",{{"R_GRAIN", 300},{"R_RUNE", 2, 106}}},
	};
	
	self.indicators = {};
	for i,quest in ipairs(self.quests) do
		table.insert(self.indicators, self:BuildIndicator(quest));
	end
	
	if(found==true) then
		self.MouseEnter = function()
			self.classLabel:SetBackground("WalmPlugins/BandOfFarmers/pictures/delete.tga");
		end
		self.MouseLeave = function()
			self.classLabel:SetBackground(self.classLabel.defaultBackground);
		end
		self.classLabel.MouseClick = function()
			bofDlg:DeleteCharacterData(self.pName);
		end
	end
	self:BuildTreeView();
	self:UpdateNodeWBData(self.pData.data);
end

function FarmNode:BuildTreeView()
	self.treeView:GetNodes():Clear();
	local indicators = {};
	for j,cmp in ipairs(self.indicators) do
		cmp:SetParent(nil);
		indicators[j]=false;
	end
	
	local totalH = 0;
	for i,key in ipairs(settings.farmList) do 
		if(settings[self.farmList[key].config]~=false) then
			local node = self:CreateKeyNode(key);
			if(node~=nil) then
				if(key=="R_CUSTOM") then
					node.indicators = {};
					for j,wad in ipairs(settings.customWads or {}) do				
						local quest={wad.id, wad.questFull, wad.repeatable, self.days[wad.repeatable], nil, nil, wad.description};
						local indicator = self:BuildIndicator(quest);
						table.insert(node.indicators, indicator);
						indicator:SetParent(node);
					end
					self.custIndicators = node.indicators;
				else
					node.indicators = {};
					for j,cmp in ipairs(self.indicators) do
						if(indicators[j]==false) then
							if(cmp.quest[6]==nil) then 
								Turbine.Shell.WriteLine("<rgb=#FF0000>ERREUR : Quest with no reward : </rgb>"..cmp.quest[1]);
							else
								for k,reward in ipairs(cmp.quest[6]) do
									if(reward[1]==key or (key=="R_LEG" and (reward[1]=="R_EVEIL" or reward[1]=="R_LEG_CRIEVEIL" or reward[1]=="R_PACKLEG"))) then
										table.insert(node.indicators, self.indicators[j]);
										indicators[j]=true;
										cmp:SetParent(node);
										break;
									end
								end
							end
						end
					end				
				end
				--if(table.getn(node.indicators)>0) then
					node.UpdateResponsive = function(width, height)
						local nbPerLine = math.floor((self.treeView:GetWidth()-40)/(22+0));
						for j,cmp in ipairs(node.indicators) do
							local col = math.mod(j-1, nbPerLine);
							local line = math.floor((j-1) / nbPerLine);
							cmp:SetPosition(40+(22+0)*col, (16+0)*line);
						end
						local h = (16)*(math.ceil(table.getn(node.indicators)/nbPerLine));
						if(h==0) then h=16; end
						node:SetHeight(h);
					end
					node:UpdateResponsive();
					totalH = totalH + node:GetHeight();
					--totalH = totalH + node:GetHeight();
					self.treeView:GetNodes():Add(node);
				--end
				
			end
		end
	end
	self.treeView:SetHeight(totalH);
	self:SetHeight(totalH+4);
end

function FarmNode:CreateKeyNode(key)
	local refData = self.farmList[key];
	if(refData==nil) then return nil; end
	local node = Turbine.UI.TreeNode();
	node:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	local gLabel = Turbine.UI.Control();
	gLabel:SetParent( node );
	gLabel:SetSize( 16, 16 );
	gLabel:SetPosition( 22, 3 );
	gLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	gLabel:SetMouseVisible(true);
	gLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/tag/"..refData.ico );
	gLabel.tooltip = GenericTooltip(gLabel, _("T_Q").._(key).." :");	
	node:SetHeight(20);
	local upLabel = Turbine.UI.Control();
	upLabel:SetParent( node );
	upLabel:SetSize( 11, 16 );
	upLabel:SetPosition( 11, 3 );
	upLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	upLabel:SetMouseVisible(true);
	upLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/dropdown_arrow_open_reversed.tga");
	local downLabel = Turbine.UI.Control();
	downLabel:SetParent( node );
	downLabel:SetSize( 11, 16 );
	downLabel:SetPosition( 0, 3 );
	downLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	downLabel:SetMouseVisible(true);
	downLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/dropdown_arrow_open.tga");
	upLabel:SetVisible(false);
	downLabel:SetVisible(false);
	node.MouseEnter = function()
		upLabel:SetVisible(true);
		downLabel:SetVisible(true);
	end
	node.MouseLeave = function()
		upLabel:SetVisible(false);
		downLabel:SetVisible(false);
	end
	upLabel.MouseClick = function()
		local index = IndexOf(settings.farmList, key);
		if(index~=nil and index~=1) then
			for i = index-1, 1, -1 do
				if(settings[self.farmList[settings.farmList[i]].config]~=false) then
					local tmp = settings.farmList[i];
					settings.farmList[i] = key;
					settings.farmList[index] = tmp;
					self:BuildTreeView();
					self:UpdateResponsive();
					Savesettings();
					return;
				end
			end
		end
	end
	downLabel.MouseClick = function()
		local index = IndexOf(settings.farmList, key);
		if(index~=nil and index~=table.getn(settings.farmList)) then
			for i = index+1, table.getn(settings.farmList), 1 do
				if(settings[self.farmList[settings.farmList[i]].config]~=false) then
					local tmp = settings.farmList[i];
					settings.farmList[i] = key;
					settings.farmList[index] = tmp;
					self:BuildTreeView();
					self:UpdateResponsive();
					Savesettings();
					return;
				end
			end		
			local tmp = settings.farmList[index+1];
			settings.farmList[index+1] = key;
			settings.farmList[index] = tmp;
			self:BuildTreeView();
			self:UpdateResponsive();
			Savesettings();
		end
	end
	return node;
end

function FarmNode:BuildIndicator(quest)
	local label = Turbine.UI.Control();
	label.quest=quest;
	label.id=quest[1];
	--label:SetParent( self );
	label:SetSize( 24, 18 );
	label:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	label:SetMouseVisible(true);
	label:SetBackground( "WalmPlugins/BandOfFarmers/pictures/tag/tag_todo.tga" );
	label.tooltip = GenericTooltip(label, quest[2]);
	label.tooltip:AddLayer( _("T_RESET")..quest[4].."s", Turbine.UI.Color(0, 1, 0.2), nil, Turbine.UI.Lotro.Font.Verdana14);
	if(quest[5]~=nil) then label.tooltip:AddLayer(  _("T_GIVEN")..quest[5], Turbine.UI.Color(0.5, 0.5, 0.5), nil, Turbine.UI.Lotro.Font.Verdana14); end
	
	if(quest[6]~=nil) then
		label.tooltip:AddLayer( _("T_REWARD"), Turbine.UI.Color(1, 1, 1), nil, Turbine.UI.Lotro.Font.Verdana14);
		for i, reward in ipairs(quest[6] or {}) do 
			local rewardstr = reward[2].." ".._(reward[1]);
			if(reward[3]~=nil) then rewardstr = rewardstr.." "..reward[3]; end
			label.tooltip:AddLayer("* "..rewardstr, Turbine.UI.Color(1, 1, 1), nil, Turbine.UI.Lotro.Font.Verdana14);
		end	
	end
	if(quest[7]~=nil) then
		label.tooltip:AddLayer(quest[7], Turbine.UI.Color(0.5, 0.5, 0.5), nil, Turbine.UI.Lotro.Font.Verdana14);
	end
	label.MouseClick = function()
		if(label.done~=true) then
			if(self.pparent.playersData[self.pDataId].data.cd==nil) then self.pparent.playersData[self.pDataId].data.cd={}; end
			if(self.pparent.playersData[self.pDataId].data.cd[quest[1]]==nil) then self.pparent.playersData[self.pDataId].data.cd[quest[1]]={}; end
			self.pparent.playersData[self.pDataId].data.cd[quest[1]].resetTime = self:ComputeResetTime(quest[3]);
			DataSave(Turbine.DataScope.Server, "BandOfFarmers_characters", self.pparent.playersData);
			self:UpdateNodeWBData(self.pparent.playersData[self.pDataId].data);
		end
	end
	return label;
end

function FarmNode:ComputeResetTime(resetDay)
	local currentGameTime = Turbine.Engine.GetLocalTime();
	local currentDate = Turbine.Engine.GetDate();
	local resetTime=currentGameTime;
	local utcResetHour = 9;
	if(type(currentDate.DayOfWeek)=="string") then currentDate.DayOfWeek=tonumber(currentDate.DayOfWeek); end
	if(resetDay==nil or resetDay==8) then resetDay=currentDate.DayOfWeek+1; end
	if(resetDay==9) then 
		if(currentDate.DayOfWeek==1) then 
			resetDay=1;
		elseif(currentDate.DayOfWeek<=5) then 
			resetDay=5; 
		else
			resetDay=1; 
		end
	end
	if(currentDate.DayOfWeek==resetDay) then 
		if(utcResetHour<currentDate.Hour) then
			resetTime=resetTime+60*60*24*7;
		end
	elseif(currentDate.DayOfWeek>resetDay) then 
		resetTime=resetTime+60*60*24*(7+resetDay-currentDate.DayOfWeek);
	else
		resetTime=resetTime+60*60*24*(resetDay-currentDate.DayOfWeek);
	end
	resetTime=(utcResetHour-currentDate.Hour)*60*60+resetTime;
	resetTime=resetTime-(currentDate.Minute)*60;
	resetTime=resetTime-currentDate.Second;
	return resetTime;
end

function FarmNode:GetPlayer()
	return self.bofData;
end

function FarmNode:UpdateResponsive(width, height)
	if(width==nil) then width=self:GetWidth() end
	if(height==nil) then height=self:GetHeight() end
	self:SetWidth(width);

	self.treeView:SetWidth( width-180-2);
    self.treeView:SetPosition( 180, 2);
	
	if(settings.showemptyfarm==true or self.hightlight or (self.counterDONE~=0 and self.counterDONE~=nil)) then
		local parentH = 5;
		for i=1, self.treeView:GetNodes():GetCount(), 1 do
			self.treeView:GetNodes():Get(i):SetWidth(self.treeView:GetWidth());
			self.treeView:GetNodes():Get(i):UpdateResponsive(self.treeView:GetWidth(), height);
			parentH = parentH + self.treeView:GetNodes():Get(i):GetHeight();
		end	
		self:SetHeight(parentH);
		height = parentH;
	
		self.leftmidbox:SetHeight(height-34);
		self.leftbotbox:SetTop(height-4);
		self.righttopbox:SetLeft(width-6);
		self.rightmidbox:SetLeft(width-6);
		self.rightmidbox:SetHeight(height-34);
		self.rightbotbox:SetPosition(width-6, height-4);
		self.centtopbox:SetWidth(width-43);
		self.centmidbox:SetSize(width-43, height-34);
		self.centbotbox:SetTop(height-4);
		self.centbotbox:SetWidth(width-43);	
		self.treeView:SetSize( width-180-2, height-4);
		self.treeView:SetHeight(height-4);
	else
		self:SetHeight(0);
	end
end

function FarmNode:UpdateNodeWBData(wbData)
	--Turbine.Shell.WriteLine("<rgb=#FF5CCD>FarmNode:UpdateNodeWBData(wbData)");
	if(wbData==nil) then return; end
	local currentGameTime = Turbine.Engine.GetLocalTime();
	local cnt=0;
	for i,cmp in ipairs(self.indicators) do
		if(wbData.cd~=nil and wbData.cd[cmp.id]~=nil and wbData.cd[cmp.id].resetTime~=nil and wbData.cd[cmp.id].resetTime>currentGameTime) then
			cmp:SetBackground( "WalmPlugins/BandOfFarmers/pictures/tag/tag_done.tga" );
			cmp.done = true;
			cnt=cnt+1;
		else
			cmp:SetBackground( "WalmPlugins/BandOfFarmers/pictures/tag/tag_todo.tga" );
			cmp.done = false;
		end	
	end 
	for i,cmp in ipairs(self.custIndicators) do
		if(wbData.cd~=nil and wbData.cd[cmp.id]~=nil and wbData.cd[cmp.id].resetTime~=nil and wbData.cd[cmp.id].resetTime>currentGameTime) then
			cmp:SetBackground( "WalmPlugins/BandOfFarmers/pictures/tag/tag_done.tga" );
			cmp.done = true;
			cnt=cnt+1;
		else
			cmp:SetBackground( "WalmPlugins/BandOfFarmers/pictures/tag/tag_todo.tga" );
			cmp.done = false;
		end	
	end
	self.counterDONE = cnt;
	if(settings.showemptyfarm~=true and (cnt>0 or self.hightlight==true)) then self:SetHeight(self.nativeHeight);
	else self:SetHeight(0);	
	end
end

function FarmNode:UpdateNodeData(p)
	-- if p~= nil and p.name == self.player.name  then
		-- self.bofData = p;
		
	-- end
end
