OptionsSlider = class( Turbine.UI.Label );

function OptionsSlider:Constructor(modesList)	  	
	Turbine.UI.Label.Constructor( self );    	
	
	self.modesList = modesList;
	self:SetSize( 200, 20 );
	self.centerbox = Turbine.UI.Label();
	self.centerbox:SetParent( self );
	
	self.centerbox:SetSize(200-12, 20);
	self.centerbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.centerbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/slider_center.tga");	
	self.rightbox = Turbine.UI.Label();
	self.rightbox:SetParent( self );
	self.rightbox:SetPosition(200-12, 0);
	self.rightbox:SetSize(12, 20);
	self.rightbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.rightbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/slider_right.tga");
	
	for i,mode in pairs(self.modesList) do
		local label = Turbine.UI.Label();
		label:SetSize(0, 20);
		label:SetPosition(0, 0);
		label:SetParent( self );
		label:SetVisible(false);
		for i,cmp in ipairs(mode.cpm) do
			if(cmp.t=="checkbox") then
				self:BuildCheckbox(label, cmp.ico, cmp.config, cmp.defaut, cmp.tooltip, cmp.fct or mode.fct);
			elseif(cmp.t=="sep") then
				self:BuildSep(label);
			end
		end
		mode.cmp = label;
	end
	self:SetResponsive();
	--self:SetVisible(false);
end

function OptionsSlider:BuildSep(parent) 
	local posX=parent:GetWidth()+5;
	local rightbox = Turbine.UI.Label();
	rightbox:SetParent( self );
	rightbox:SetPosition(posX, 2);
	rightbox:SetSize(2, self:GetHeight()-2);
	rightbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	rightbox:SetBackColor( Turbine.UI.Color( 123/256, 123/256, 128/256) );
	parent:SetWidth(posX+10);
end

function OptionsSlider:BuildCheckbox(parent, ico, config, defaultcheck, tooltip, fct) --{ico="tag_vertues.tga",t="checkbox",config="farm_show_vertue"}
	
	local posX=parent:GetWidth()+5;
	local checkbox = Turbine.UI.Lotro.CheckBox();
	checkbox:SetParent(parent);
	checkbox:SetMultiline( false );
	checkbox:SetPosition(posX, 4);
	checkbox:SetSize(16, 16);
	if(settings[config]==nil) then 
		checkbox:SetChecked(defaultcheck);
	else
		checkbox:SetChecked(settings[config]==true);
	end
	checkbox.CheckedChanged = function(sender, args)
		settings[config]=checkbox:IsChecked();
		if(fct~=nil) then fct(); end
	end	
	local gLabel = Turbine.UI.Control();
	gLabel:SetParent( parent );
	gLabel:SetSize( 16, 16 );
	gLabel:SetPosition( posX+20, 3 );
	gLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	gLabel:SetMouseVisible(true);
	gLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/tag/"..ico );
	if(tooltip~=nil) then
		gLabel.tooltip = GenericTooltip(gLabel, tooltip);
		checkbox.tooltip = GenericTooltip(checkbox, tooltip);
	end
	parent:SetWidth(posX+40);
end

function OptionsSlider:SetMode(modeId)
	if(self.modesList[modeId]==nil or self.modesList[modeId].cmp==nil) then
		self:SetVisible(false);
	else
		for i,mode in ipairs(self.modesList) do
			if(mode.cmp~=nil) then mode.cmp:SetVisible(false); end
		end
		self:SetVisible(true);
		self.modesList[modeId].cmp:SetVisible(true);
		self:SetWidth(self.modesList[modeId].cmp:GetWidth()+5);
		self:SetResponsive();
	end
end

function OptionsSlider:SetResponsive()
	self.centerbox:SetWidth(self:GetWidth()-12);
	self.rightbox:SetLeft(self:GetWidth()-12);
end
