
PlayerTokenNode = class( Turbine.UI.TreeNode );

function PlayerTokenNode:Constructor(p, item, hightlight, width)
	
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( width, 35 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	
	self.leftbox = Turbine.UI.Label();
	self.leftbox:SetParent( self );
	self.leftbox:SetPosition(0, 0);
	self.leftbox:SetSize(37, 35);
	self.leftbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.leftbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box_l.tga");	
	self.rightbox = Turbine.UI.Label();
	self.rightbox:SetParent( self );
	self.rightbox:SetSize(6, 35);
	self.rightbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.rightbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box_r.tga");
	self.middlebox = Turbine.UI.Label();
	self.middlebox:SetParent( self );
	self.middlebox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.middlebox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box_m.tga");
	self.middlebox:SetPosition(37, 0);	
	
	self.playerNameLabel = Turbine.UI.Label();
	self.playerNameLabel:SetParent( self );
	self.playerNameLabel:SetSize( 180, 28 );
	self.playerNameLabel:SetPosition( 42, 3 );
	self.playerNameLabel:SetZOrder(100);
	self.playerNameLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.playerNameLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.playerNameLabel:SetMouseVisible( false );
	self.playerNameLabel:SetText("["..p.playerLevel.."] "..p.playerName);
	
	if(hightlight==true) then
		self.playerNameLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	end
	
	-- local value = {};
	-- value.playerName = player.name;
	-- value.playerLevel = player.data.level;
	-- value.playerClass = player.data.playerClass;
	-- value.playerQuantity = player.data.wallet[k].quantity;	
	
	
	self.classLabel = Turbine.UI.Control();
	self.classLabel:SetParent( self );
	self.classLabel:SetSize( 20, 20 );
	self.classLabel:SetPosition( 9, 7 );
	if(p.playerClass == 172) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_champion_20.tga");
	elseif(p.playerClass == 214) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_beorning_20.tga");
	elseif(p.playerClass == 40) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_burglar_20.tga");
	elseif(p.playerClass == 23) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_guardian_20.tga");
	elseif(p.playerClass == 194) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_warden_20.tga");
	elseif(p.playerClass == 193) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_runekeeper_20.tga");
	elseif(p.playerClass == 185) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_loremaster_20.tga");
	elseif(p.playerClass == 162) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_hunter_20.tga");
	elseif(p.playerClass == 31) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_minstrel_20.tga");
	elseif(p.playerClass == 24) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_captain_20.tga");
	elseif(p.playerClass == 215) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_brawler_20.tga");
	else
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga");
		self.classLabel:SetPosition( 6, 5 );
		self.classLabel:SetSize( 26, 24 );
	end
	self.classLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.classLabel:SetMouseVisible( false );

	self.imageLabel = Turbine.UI.Control();
	self.imageLabel:SetParent( self );
	self.imageLabel:SetSize( 30, 30 );
	self.imageLabel:SetPosition( 200, 2 );
	self.imageLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.imageLabel:SetBackground( item.image );

	self.valueLabel = Turbine.UI.Label();
	self.valueLabel:SetParent( self );
	self.valueLabel:SetSize( 40, 16 );
	self.valueLabel:SetPosition( 230, 11 );
	self.valueLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.valueLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	self.valueLabel:SetMouseVisible( false );
	self.valueLabel:SetText(p.playerQuantity);
	self:UpdateResponsive(self:GetWidth(), self:GetHeight());
end

function PlayerTokenNode:UpdateResponsive(width, height)
	self:SetWidth(width);
	self.rightbox:SetPosition(width-6, 0);
	self.middlebox:SetSize(width-43, 35);
	
	self.imageLabel:SetLeft( width-112 );
	self.valueLabel:SetLeft( width-82 );
end

function PlayerTokenNode:GetPlayer()
	return self.player;
end

function PlayerTokenNode:UpdateNodeData(p)
	-- if p~= nil and p.name == self.player.name  then
		-- self.player = p;
		-- self.goldValueLabel:SetText(math.floor(self.player.data.gold/100000));
		-- self.silverValueLabel:SetText(math.floor(self.player.data.gold/100%1000));	
		-- self.copperValueLabel:SetText(math.floor(self.player.data.gold%100));	
		-- self.playerNameLabel:SetText("["..self.player.data.level.."] "..self.player.name);
	-- end
end
