
PlayerTraitNode = class( Turbine.UI.TreeNode );

function PlayerTraitNode:Constructor(parent, pData, hightlight, i)
	self.pName = pData.name;
	self.pData = pData;
	
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( width, 35 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	
	self.leftbox = Turbine.UI.Label();
	self.leftbox:SetParent( self );
	self.leftbox:SetPosition(0, 0);
	self.leftbox:SetSize(37, 35);
	self.leftbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.leftbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box_l.tga");	
	self.rightbox = Turbine.UI.Label();
	self.rightbox:SetParent( self );
	self.rightbox:SetSize(6, 35);
	self.rightbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.rightbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box_r.tga");
	self.middlebox = Turbine.UI.Label();
	self.middlebox:SetParent( self );
	self.middlebox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.middlebox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box_m.tga");
	self.middlebox:SetPosition(37, 0);	
	
	self.playerNameLabel = Turbine.UI.Label();
	self.playerNameLabel:SetParent( self );
	self.playerNameLabel:SetSize( 180, 28 );
	self.playerNameLabel:SetPosition( 42, 3 );
	self.playerNameLabel:SetZOrder(100);
	self.playerNameLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.playerNameLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.playerNameLabel:SetMouseVisible( false );
	self.playerNameLabel:SetText("["..(self.pData.data.level or "??").."] "..self.pName);
	
	if(hightlight==true) then
		self.playerNameLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	end
	local found = true;
	self.classLabel = Turbine.UI.Control();
	self.classLabel:SetParent( self );
	self.classLabel:SetSize( 20, 20 );
	self.classLabel:SetPosition( 9, 7 );
	if(self.pData.data.playerClass == 172) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_champion_20.tga";
	elseif(self.pData.data.playerClass == 214) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_beorning_20.tga";
	elseif(self.pData.data.playerClass == 40) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_burglar_20.tga";
	elseif(self.pData.data.playerClass == 23) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_guardian_20.tga";
	elseif(self.pData.data.playerClass == 194) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_warden_20.tga";
	elseif(self.pData.data.playerClass == 193) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_runekeeper_20.tga";
	elseif(self.pData.data.playerClass == 185) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_loremaster_20.tga";
	elseif(self.pData.data.playerClass == 162) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_hunter_20.tga";
	elseif(self.pData.data.playerClass == 31) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_minstrel_20.tga";
	elseif(self.pData.data.playerClass == 24) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_captain_20.tga";
	elseif(self.pData.data.playerClass == 215) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_brawler_20.tga";
	else
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga";
		self.classLabel:SetPosition( 6, 5 );
		self.classLabel:SetSize( 26, 24 );
		found = false;
	end
	self.classLabel:SetBackground(self.classLabel.defaultBackground);
	self.classLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.classLabel:SetMouseVisible( false );

	self.imageLabel = Turbine.UI.Control();
	self.imageLabel:SetParent( self );
	self.imageLabel:SetSize( 23, 27 );
	self.imageLabel:SetPosition( 200, 4 );
	self.imageLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.imageLabel:SetMouseVisible(true);
	self.imageLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/trait.tga" );

	self.valueLabel = Turbine.UI.Label();
	self.valueLabel:SetParent( self );
	self.valueLabel:SetSize( 60, 16 );
	self.valueLabel:SetPosition( 230, 11 );
	self.valueLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.valueLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	self.valueLabel:SetMouseVisible( false );
	self.valueLabel:SetText("0 / 101");
	self:UpdateResponsive(self:GetWidth(), self:GetHeight());
	
	if(found==true) then
		self.MouseEnter = function()
			self.classLabel:SetBackground("WalmPlugins/BandOfFarmers/pictures/delete.tga");
		end
		self.MouseLeave = function()
			self.classLabel:SetBackground(self.classLabel.defaultBackground);
		end
		self.classLabel.MouseClick = function()
			bofDlg:DeleteCharacterData(self.pName);
		end
	end	
	if(self.pData~=nil and self.pData.data~=nil and self.pData.data.class~=nil) then
		self:UpdateNodeWBData(self.pData.data);
	else
		self.counter = (pData.data.forceClassCount or 0);	
		self.valueLabel:SetText(self.counter.." / 101");
		if(hightlight==true) then
			self.leftArrow = Turbine.UI.Label();
			self.leftArrow:SetParent( self );
			self.leftArrow:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
			self.leftArrow:SetBackground("WalmPlugins/BandOfFarmers/pictures/traits/Arrow_Gold_Left.tga");
			self.leftArrow:SetSize(16, 16);	
			self.leftArrow:SetTop(self.imageLabel:GetTop()+self.imageLabel:GetHeight()/2-8);
			self.leftArrow.tooltip = GenericTooltip(self.leftArrow, _("TRAIT_L1"));
			self.leftArrow.tooltip:AddLayer(_("TRAIT_A"),  Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14);
			self.rightArrow = Turbine.UI.Label();
			self.rightArrow:SetParent( self );
			self.rightArrow:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
			self.rightArrow:SetBackground("WalmPlugins/BandOfFarmers/pictures/traits/Arrow_Gold_Right.tga");
			self.rightArrow:SetSize(16, 16);
			self.rightArrow:SetTop(self.leftArrow:GetTop());
			self.rightArrow.tooltip = GenericTooltip(self.rightArrow, _("TRAIT_R1"));
			self.rightArrow.tooltip:AddLayer(_("TRAIT_A"),  Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14);
			self.leftArrow:SetVisible(self.counter>0);	
			self.rightArrow:SetVisible(self.counter<101);	
			self.leftArrow.MouseClick = function()
				self.counter = self.counter-1;
				self.valueLabel:SetText(self.counter.." / 101");
				self.leftArrow:SetVisible(self.counter>0);
				self.rightArrow:SetVisible(self.counter<101);			
				if(parent.playersData[i].data~=nil) then parent.playersData[i].data = {}; end
				parent.playersData[i].data.forceClassCount = self.counter;
				DataSave(Turbine.DataScope.Server, "BandOfFarmers_characters", parent.playersData);
			end
			self.rightArrow.MouseClick = function()
				self.counter = self.counter+1;
				self.valueLabel:SetText(self.counter.." / 101");
				self.leftArrow:SetVisible(self.counter>0);
				self.rightArrow:SetVisible(self.counter<101);
				if(parent.playersData[i].data~=nil) then parent.playersData[i].data = {}; end
				parent.playersData[i].data.forceClassCount = self.counter;
				DataSave(Turbine.DataScope.Server, "BandOfFarmers_characters", parent.playersData);
			end			
		end		
	end
end

function PlayerTraitNode:UpdateResponsive(width, height)
	self:SetWidth(width);
	self.rightbox:SetPosition(width-6, 0);
	self.middlebox:SetSize(width-43, 35);
	
	self.imageLabel:SetLeft( width-112 );
	self.valueLabel:SetLeft( width-82 );
	
	if(self.leftArrow~=nil) then self.leftArrow:SetLeft(self.imageLabel:GetLeft()-16); end
	if(self.rightArrow~=nil) then self.rightArrow:SetLeft(self.imageLabel:GetLeft()+self.imageLabel:GetWidth()); end
end

function PlayerTraitNode:GetPlayer()
	return self.player;
end

function PlayerTraitNode:UpdateNodeWBData(wbData)
	local counter=0;
	if(wbData~=nil and wbData.class~=nil) then
		local successColor = Turbine.UI.Color(207/255,181/255,59/255);
		local failedColor = Turbine.UI.Color(207/255,181/255,59/255);
		local wColor = Turbine.UI.Color(1, 1, 1);
		self.imageLabel.tooltip = GenericTooltip(self.imageLabel, "Points de traits de "..self.pName);
		local c=0; total=55;
		if(wbData.playerClass~=214) then
			if(wbData.class[10001]~=nil) then c=c+(wbData.class[10001].value or 0); end
			self.imageLabel.tooltip:AddLayer( "* Au gain de niveaux : "..c.." / "..total, wColor, nil, Turbine.UI.Lotro.Font.Verdana14, nil);
			counter = counter + c;
		else
			total=58;
			if(wbData.class[10020]~=nil) then c=c+(wbData.class[10020].value or 0); end
			self.imageLabel.tooltip:AddLayer( "* Au gain de niveaux : "..c.." / "..total, wColor, nil, Turbine.UI.Lotro.Font.Verdana14, nil);
			counter = counter + c;		
		end
		c=0; total=0;
		if(wbData.class[10003]~=nil) then c=c+(wbData.class[10003].value or 0); total=wbData.class[10003].progress; end
		if(wbData.class[10004]~=nil) then c=c+(wbData.class[10004].value or 0); end
		self.imageLabel.tooltip:AddLayer( "* Via les Batailles Epiques : "..c.." / 2\n("..total.." points de promotion sur 200)", wColor, nil, Turbine.UI.Lotro.Font.Verdana14, nil);
		counter = counter + c; c=0;
		for i=10010, 10018 do
			if(wbData.class[i]~=nil) then c=c+(wbData.class[i].value or 0); end
		end	
		total=2; if(wbData.playerClass==214) then total=1; end if(wbData.playerClass==215) then total=4; end
		self.imageLabel.tooltip:AddLayer( "* Prouesses de classe : "..c.." / 8", wColor, nil, Turbine.UI.Lotro.Font.Verdana14, nil);
		counter = counter + c; c=0;
		if(wbData.class[10116]~=nil and wbData.playerClass~=214 and wbData.playerClass~=215) then c=c+(wbData.class[10116].value or 0); end
		if(wbData.class[10035]~=nil and wbData.playerClass==215) then c=c+(wbData.class[10035].value or 0); end
		if(wbData.class[10036]~=nil and wbData.playerClass==215) then c=c+(wbData.class[10036].value or 0); end
		if(wbData.class[10037]~=nil and wbData.playerClass==215) then c=c+(wbData.class[10037].value or 0); end
		if(wbData.class[10005]~=nil) then c=c+(wbData.class[10005].value or 0); end
		self.imageLabel.tooltip:AddLayer( "* Qu\195\170tes de classe : "..c.." / "..total, wColor, nil, Turbine.UI.Lotro.Font.Verdana14, nil);
		counter = counter + c; c=0;
		if(wbData.class[10030]~=nil) then c=c+(wbData.class[10030].value or 0); end
		if(wbData.class[10031]~=nil) then c=c+(wbData.class[10031].value or 0); end
		if(wbData.class[10032]~=nil) then c=c+(wbData.class[10032].value or 0); end
		self.imageLabel.tooltip:AddLayer( "* Livres de classe niv.39 : "..c.." / 3", wColor, nil, Turbine.UI.Lotro.Font.Verdana14, nil);
		-- TODO quêtes de classe
		counter = counter + c; c=0;
		for i=10200, 10214 do
			if(wbData.class[i]~=nil) then c=c+(wbData.class[i].value or 0); end
		end
		if(wbData.class[10214]~=nil) then c=c+(wbData.class[10214].value or 0); end
		if(wbData.class[10215]~=nil) then c=c+(wbData.class[10215].value or 0); end
		self.imageLabel.tooltip:AddLayer( "* Livres \195\169piques : "..c.." / 16", wColor, nil, Turbine.UI.Lotro.Font.Verdana14, nil);
		counter = counter + c; c=0;
		if(wbData.playerClass~=214) then
			if(wbData.class[10115]~=nil) then c=c+(wbData.class[10115].value or 0); end
			self.imageLabel.tooltip:AddLayer( "* Prouesse de Livres \195\169piques Moria : "..c.." / 1", wColor, nil, Turbine.UI.Lotro.Font.Verdana14, nil);
			counter = counter + c; c=0;
		end
		if(wbData.class[10117]~=nil) then c=c+(wbData.class[10117].value or 0); end	
		self.imageLabel.tooltip:AddLayer( "* Qu\195\170tes du Sang d'Azog : "..c.." / 1", wColor, nil, Turbine.UI.Lotro.Font.Verdana14, nil);
		counter = counter + c; c=0;		
		if(wbData.class[10100]~=nil) then c=c+(wbData.class[10100].value or 0); end
		if(wbData.class[10101]~=nil) then c=c+(wbData.class[10101].value or 0); end
		if(wbData.class[10104]~=nil) then c=c+(wbData.class[10104].value or 0); end	
		self.imageLabel.tooltip:AddLayer( "* Prouesses de l'Ancien An\195\179rien : "..c.." / 3", wColor, nil, Turbine.UI.Lotro.Font.Verdana14, nil);
		counter = counter + c; c=0;
		for i=10105, 10108 do
			if(wbData.class[i]~=nil) then c=c+(wbData.class[i].value or 0); end
		end		
		self.imageLabel.tooltip:AddLayer( "* Qu\195\170tes du Centre du Gondor : "..c.." / 4", wColor, nil, Turbine.UI.Lotro.Font.Verdana14, nil);
		counter = counter + c; c=0;
		for i=10109, 10113 do
			if(wbData.class[i]~=nil) then c=c+(wbData.class[i].value or 0); end
		end		
		self.imageLabel.tooltip:AddLayer( "* Qu\195\170tes du Rohan Ouest : "..c.." / 5", wColor, nil, Turbine.UI.Lotro.Font.Verdana14, nil);
		if(wbData.playerClass~=214 and wbData.playerClass~=215) then
			counter = counter + c; c=0;
			if(wbData.class[10114]~=nil) then c=c+(wbData.class[10114].value or 0); end
			self.imageLabel.tooltip:AddLayer( "* R\195\169putation \"Garnison de Fer\" : "..c.." / 1", wColor, nil, Turbine.UI.Lotro.Font.Verdana14, nil);	
		end
		counter = counter + c; c=0;
		self.imageLabel.tooltip:AddLayer("\nCes informations sont automatiquement récupérées depuis votre plugin pr\195\169f\195\169r\195\169 : \"Warbands and Deeds Slayer\".", Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14);		
	end
	self.valueLabel:SetText(counter.." / 101");
	if(counter==0) then self:SetHeight(0); end
	self.counter = counter;
	if(self.rightArrow~=nil) then self.rightArrow:SetVisible(false); end
	if(self.leftArrow~=nil) then self.leftArrow:SetVisible(false); end
end

function PlayerTraitNode:UpdateNodeData(p)
	-- if p~= nil and p.name == self.player.name  then
		-- self.player = p;
		-- self.goldValueLabel:SetText(math.floor(self.player.data.gold/100000));
		-- self.silverValueLabel:SetText(math.floor(self.player.data.gold/100%1000));	
		-- self.copperValueLabel:SetText(math.floor(self.player.data.gold%100));	
		-- self.playerNameLabel:SetText("["..self.player.data.level.."] "..self.player.name);
	-- end
end
