TextNode = class( Turbine.UI.TreeNode );

function TextNode:Constructor(title, value, width, height)
	Turbine.UI.TreeNode.Constructor( self );
	self.nativewidth = 290;
	self.nativeheight = 16;
	self.valueLenght = 30;
	if(width~=nil and height~=nil) then
		self.nativewidth = width;
		self.nativeheight = height;
	end
	self:SetSize( self.nativewidth, self.nativeheight );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	
	self.labelKey = Turbine.UI.Label();
	self.labelKey:SetParent( self );
	self.labelKey:SetPosition( 0, 0 );
	self.labelKey:SetSize( self.nativewidth-self.valueLenght, self.nativeheight );	
	self.labelKey:SetZOrder(100);
	--self.labelKey:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );	
	self.labelKey:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.labelKey:SetMouseVisible( false );
	self.labelKey:SetText(title);

	self.valueKey = Turbine.UI.Label();
	self.valueKey:SetParent( self );
	self.valueKey:SetPosition( self.nativewidth-self.valueLenght, 0 );
	self.valueKey:SetSize( self.valueLenght, self.nativeheight );	
	self.valueKey:SetZOrder(100);
	--self.labelKey:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );	
	self.valueKey:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.valueKey:SetMouseVisible( false );
	self.valueKey:SetText(value);	
	
	self.SelectedChanged = function ()
		if(self:IsSelected() == true) then
			self.labelKey:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
			self.valueKey:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
		else
			self.labelKey:SetForeColor(Turbine.UI.Color( 1, 1, 1 ));
			self.valueKey:SetForeColor(Turbine.UI.Color( 1, 1, 1 ));
		end
	
	end
	
	--self:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
end

function TextNode:UpdateResponsive(width, height)
	self:SetSize(width, height);
	self.valueKey:SetPosition( width-self.valueLenght, 0 );
	self.labelKey:SetSize( width-self.valueLenght, self.nativeheight );
end

function TextNode:SetText(value)
	self.labelKey:SetText(value);
	if(value==nil or value=="") then
		self:SetSize( self.nativewidth, 0 );
	else
		self:SetSize( self.nativewidth, self.nativeheight );
	end	
end

function TextNode:GetText()
	return self.labelKey:GetText();
end

function TextNode:GetValue()
	return self.valueKey:GetText();
end

function TextNode:SetValue(value)
	self.valueKey:SetText(value);
	if(value==nil or value=="") then
		self:SetSize( self.nativewidth, 0 );
	else
		self:SetSize( self.nativewidth, self.nativeheight );
	end
end