import "WalmPlugins.BandOfFarmers.TextNode";
import "WalmPlugins.BandOfFarmers.PlayerTokenNode";


TokenSearchNode = class( Turbine.UI.TreeNode );


function TokenSearchNode:Constructor(playersData, parentTreeView)
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( 312, settings.csearch_height or 70 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--self:SetBackground("WalmPlugins/BandOfFarmers/background_blue_large.tga");
	
	self.searching = true;

	self.lefttopbox = Turbine.UI.Label();
	self.lefttopbox:SetParent( self );
	self.lefttopbox:SetPosition(0, 0);
	self.lefttopbox:SetSize(37, 30);
	self.lefttopbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.lefttopbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_lt.tga");	
	self.leftmidbox = Turbine.UI.Label();
	self.leftmidbox:SetParent( self );
	self.leftmidbox:SetPosition(0, 30);
	self.leftmidbox:SetSize(37, 1);
	self.leftmidbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.leftmidbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_lm.tga");
	self.leftbotbox = Turbine.UI.Label();
	self.leftbotbox:SetParent( self );
	self.leftbotbox:SetPosition(0, 30);
	self.leftbotbox:SetSize(37, 4);
	self.leftbotbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.leftbotbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_lb.tga");	
	self.righttopbox = Turbine.UI.Label();
	self.righttopbox:SetParent( self );
	self.righttopbox:SetPosition(0, 0);
	self.righttopbox:SetSize(6, 30);
	self.righttopbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.righttopbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_rt.tga");	
	self.rightmidbox = Turbine.UI.Label();
	self.rightmidbox:SetParent( self );
	self.rightmidbox:SetPosition(0, 30);
	self.rightmidbox:SetSize(6, 1);
	self.rightmidbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.rightmidbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_rm.tga");
	self.rightbotbox = Turbine.UI.Label();
	self.rightbotbox:SetParent( self );
	self.rightbotbox:SetPosition(0, 30);
	self.rightbotbox:SetSize(6, 4);
	self.rightbotbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.rightbotbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_rb.tga");
	self.centtopbox = Turbine.UI.Label();
	self.centtopbox:SetParent( self );
	self.centtopbox:SetPosition(37, 0);
	self.centtopbox:SetSize(1, 30);
	self.centtopbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.centtopbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_ct.tga");	
	self.centmidbox = Turbine.UI.Label();
	self.centmidbox:SetParent( self );
	self.centmidbox:SetPosition(37, 30);
	self.centmidbox:SetSize(1, 1);
	self.centmidbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.centmidbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_cm.tga");
	self.centbotbox = Turbine.UI.Label();
	self.centbotbox:SetParent( self );
	self.centbotbox:SetPosition(37, 30);
	self.centbotbox:SetSize(1, 4);
	self.centbotbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.centbotbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_cb.tga");	
	
	self.textLabel = Turbine.UI.Label();
	self.textLabel:SetParent( self );
	self.textLabel:SetSize( 140, 14 );
	self.textLabel:SetPosition( 40, 6 );
	self.textLabel:SetZOrder(100);
	self.textLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.textLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.textLabel:SetMouseVisible( false );
	self.textLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	self.textLabel:SetText(_("SEARCH"));
	
	self.resultLabel = Turbine.UI.Label();
	self.resultLabel:SetParent( self );
	self.resultLabel:SetSize( 65, 20 );
	self.resultLabel:SetPosition( 245, 0 );
	self.resultLabel:SetZOrder(100);
	self.resultLabel:SetFont( Turbine.UI.Lotro.Font.Verdana10	 );	
	self.resultLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	self.resultLabel:SetMouseVisible( false );
	--self.resultLabel:SetBackColor(Turbine.UI.Color( 1, 1, 0.5 ));
	self.resultLabel:SetText("XXX résultats");	
	
	self.classLabel = Turbine.UI.Control();
	self.classLabel:SetParent( self );
	self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga");
	self.classLabel:SetPosition( 6, 5 );
	self.classLabel:SetSize( 26, 24 );
	self.classLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.classLabel:SetMouseVisible( false );

	self.textArea = Turbine.UI.Lotro.TextBox();
	self.textArea:SetParent( self );
	self.textArea:SetPosition( 110, self.textLabel:GetTop()-3 );
	self.textArea:SetSize( 130 , 20 );
	self.textArea:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.textArea:SetMultiline(false);
	self.textArea:SetText(settings.tokenSearchStr);
	self.textArea.TextChanged = function ()
		self:BuildTokensList(playersData, string.lower(self.textArea:GetText()));	
	end

	local topTreeView = 24;
	self.treeView = Turbine.UI.TreeView();
    self.treeView:SetParent( self );
    self.treeView:SetPosition( 42, topTreeView );
    self.treeView:SetSize( self:GetWidth()-60, 40 );
    self.treeView:SetIndentationWidth( 15 );
	-- local sortMethod = function (node1, node2)
		-- if node1== nil or node2==nil then
			-- return true;
		-- end
		-- if (node1:GetText() > node2:GetText()) then
			-- return true
		-- end
	-- end
    self.treeView:SetSortMethod( sortMethod );
	self.treeViewScrollBar = Turbine.UI.Lotro.ScrollBar();
    self.treeViewScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
    self.treeViewScrollBar:SetParent( self );
    self.treeViewScrollBar:SetPosition(self:GetWidth()-15, topTreeView );
    self.treeViewScrollBar:SetSize( 10, self.treeView:GetHeight() );
	self.treeView:SetVerticalScrollBar( self.treeViewScrollBar );



	self:BuildTokensList(playersData, settings.tokenSearchStr or "");
	
	self.treeView.SelectedNodeChanged = function()
		local node = self.treeView:GetSelectedNode();
		if(node.item == nil) then return; end;
		--Turbine.Shell.WriteLine("<rgb=#FF5CCD>BandOfFarmers: Node séléctionné : ".. node:GetText() .."</rgb>");
		-- for i=1 , parentTreeView:GetNodes():GetCount() , 1 do
			-- if(parentTreeView:GetNodes():Get(i).searching ~= true) then 
				-- parentTreeView:GetNodes():RemoveAt(i); 
				-- i = i-1; 
			-- end
		-- end
		local pnode = parentTreeView:GetNodes():Get(1);
		parentTreeView:GetNodes():Clear();
		parentTreeView:GetNodes():Add(pnode);
		if(node.itemValues ~= nil) then
			for i=1 , table.getn(node.itemValues) , 1 do
				local node = PlayerTokenNode(node.itemValues[i], node.item, nil, parentTreeView:GetWidth());
				parentTreeView:GetNodes():Add(node);
			end
		end
	end
	self.resizer = Turbine.UI.Label();
	self.resizer:SetParent( self );
	self.resizer:SetSize(100, 10);
	self.resizer:SetBackground("WalmPlugins/BandOfFarmers/pictures/v_resize.jpg");
	self.resizer:SetPosition(self:GetWidth()/2-50, self:GetHeight()-10);
	self.resizer:SetZOrder(self:GetZOrder()+10);
	
	self.resizer.MouseDown = function( sender, args )
		if(args.Button == Turbine.UI.MouseButton.Left) then
			sender.dragStartX = args.X;
			sender.dragStartY = args.Y;
			sender.dragging = true;
			sender.dragged = false;
		end
	end
	self.resizer.MouseUp = function( sender, args )
		if (args.Button == Turbine.UI.MouseButton.Left) then			
			if (sender.dragging) then
				sender.dragging = false;
			end
			settings.csearch_height = self:GetHeight();
			Savesettings();
		end
	end
	self.resizer.MouseMove = function(sender,args)
		if ( sender.dragging ) then
			local height = self:GetHeight() + args.Y - sender.dragStartY;
			if(height>70) then 
				self:SetHeight(height);
			end
			self:UpdateResponsive(self:GetWidth(), self:GetHeight());
		end
	end	
	self:UpdateResponsive(self:GetWidth(), self:GetHeight());
end

function TokenSearchNode:UpdateResponsive(width, height)
	self:SetWidth(width);
	self.resizer:SetPosition(self:GetWidth()/2-50, self:GetHeight()-10);
    self.treeView:SetSize( self:GetWidth()-60, self:GetHeight()-30 );

	self.leftmidbox:SetHeight(height-34);
	self.leftbotbox:SetTop(height-4);
	self.righttopbox:SetLeft(width-6);
	self.rightmidbox:SetLeft(width-6);
	self.rightmidbox:SetHeight(height-34);
	self.rightbotbox:SetPosition(width-6, height-4);
	self.centtopbox:SetWidth(width-43);
	self.centmidbox:SetSize(width-43, height-34);
	self.centbotbox:SetTop(height-4);
	self.centbotbox:SetWidth(width-43);
	
	self.textArea:SetWidth(width-176);
	self.resultLabel:SetLeft(width-67);
	
	self.treeViewScrollBar:SetPosition(self:GetWidth()-15, 24 );
    self.treeViewScrollBar:SetSize( 10, self.treeView:GetHeight() );
	for i=1 , self.treeView:GetNodes():GetCount() , 1 do
		local node = self.treeView:GetNodes():Get(i);
		node:UpdateResponsive(self:GetWidth()-60, 12);
	end		
end

function TokenSearchNode:BuildTokensList(playersData, search)
	self.treeView:GetNodes():Clear();
	
	-- local parentNode = TextNode("Je suis le parent");
	-- self.treeView:GetNodes():Add(parentNode);
	
	local result = {};
	for i=1 , table.getn(playersData), 1 do
		local player = playersData[i];
		if player.data.wallet ~= nil then
			for k=1 , table.getn(player.data.wallet) , 1 do
				if string.match(string.lower(player.data.wallet[k].name), search) then
					local found = false;				
					--for j=1 , self.treeView:GetNodes():GetCount(), 1 do
					for j=1 , table.getn(result), 1 do
						local node = result[j];
						--local node = self.treeView:GetNodes():Get(j);
						if(node.item ~= nil and node.item.name == player.data.wallet[k].name) then
							local value = {};
							value.playerName = player.name;
							value.playerLevel = player.data.level;
							value.playerClass = player.data.playerClass;
							value.playerQuantity = player.data.wallet[k].quantity;
							--node:SetValue(value.playerQuantity + node:GetValue());
							node.total = node.total + player.data.wallet[k].quantity;
							table.insert(node.itemValues, value);
							found = true;
						end
					end
					if (found == false) then
						--local node = TextNode(player.data.wallet[k].name, player.data.wallet[k].quantity, 250, 12);
						local node = {};
						node.item = player.data.wallet[k];
						node.itemValues = {};
						node.total = player.data.wallet[k].quantity;
						local value = {};
						value.playerName = player.name;
						value.playerLevel = player.data.level;
						value.playerClass = player.data.playerClass;
						value.playerQuantity = player.data.wallet[k].quantity;
						table.insert(node.itemValues, value);
						table.insert(result, node);
					end
				end
			end
		end
	
	end
	table.sort(result, sorttokensbynumber);
	for j=1 , table.getn(result), 1 do
		local node = TextNode(result[j].item.name, result[j].total, 250, 12);
		table.sort(result[j].itemValues, sortownersbynumber);
		node.item = result[j].item;
		node.itemValues = result[j].itemValues;
		self.treeView:GetNodes():Add(node);		
	end
	-- parentNode:SetText("Nombre de résultats: "..parentNode:GetChildNodes():GetCount());
	-- self.treeView:ExpandAll();
	self.resultLabel:SetText(""..self.treeView:GetNodes():GetCount().. _("RESULTS"));
	settings.tokenSearchStr = search;
	Savesettings();
end

function sorttokensbyname(t1,t2)
	if t1== nil or t2==nil then
		return true;
	end
	if (t1.item.name < t2.item.name) then
		return true
	end
end
function sorttokensbynumber(t1,t2)
	if t1== nil or t2==nil then
		return true;
	end
	if (t1.total > t2.total) then
		return true
	end
end
function sortownersbynumber(t1,t2)
	if t1== nil or t2==nil then
		return true;
	end
	if (t1.playerQuantity > t2.playerQuantity) then
		return true
	end
end